;	
;	clipz80a.s
;
;	P/ECE Z80 Emulator
;
;	CLiP - Common Library for P/ECE
;	Copyright (C) 2001-2003 Naoyuki Sawa
;
;	* Sat Nov 22 06:00:00 JST 2003 Naoyuki Sawa
;	- 쐬JnB
;
#include "clipz80a.h"
#ifdef  Z80_ASM

	.code
	.align 1

;****************************************************************************
;
;****************************************************************************

;
;	Z80\
;
;===== WX^ =====
#define F	 0
#define A	 1
#define C	 2
#define B	 3
#define E	 4
#define D	 5
#define L	 6
#define H	 7
#define AF	 0
#define BC	 2
#define DE	 4
#define HL	 6
#define AF2	 8
#define BC2	10
#define DE2	12
#define HL2	14
#define IXL	16
#define IXH	17
#define IYL	18
#define IYH	19
#define IX	16
#define IY	18
#define SP	20
#define PC	22
;=====  =====
#define IFF1	32
#define IFF2	33
#define IM	34
#define HALT	35
#define CYCLE	36
;===== O֐ =====
#define READ	48
#define WRITE	52
#define IN	56
#define OUT	60

;****************************************************************************
;	8-Bit Load Group
;****************************************************************************

#macro LD_r_IlmI $1
	pushn %r0
	;
	xld.w %r10, [%r12+READ]
	ld.w %r13, %r15			; lm
	xsll %r13, 8
	or %r13, %r14
	call.d %r10
	ld.w %r0, %r12			; *delay*
	xld.b [%r0+$1], %r10
	;
	popn %r0
	ret
#endm

#macro LD_r_IrrI $1, $2
	pushn %r0
	;
	xld.w %r10, [%r12+READ]
	xld.uh %r13, [%r12+$2]		; *anti-interlock*
	call.d %r10
	ld.w %r0, %r12			; *delay*
	xld.b [%r0+$1], %r10
	;
	popn %r0
	ret
#endm

#macro LD_r_Irr_dI $1, $2
	pushn %r0
	;
	xld.w %r10, [%r12+READ]
	xld.uh %r13, [%r12+$2]		; rr+d
	ld.b %r14, %r14			; *anti-interlock*
	add %r13, %r14
	call.d %r10
	ld.w %r0, %r12			; *delay*
	xld.b [%r0+$1], %r10
	;
	popn %r0
	ret
#endm

#macro LD_IlmI_r $1
	xld.w %r10, [%r12+WRITE]
	ld.w %r13, %r15			; lm
	xsll %r13, 8
	or %r13, %r14
	xld.ub %r14, [%r12+$1]
	call %r10
	ret
#endm

#macro LD_IrrI_n $1
	xld.w %r10, [%r12+WRITE]
	xld.uh %r13, [%r12+$1]		; *anti-interlock*
	call %r10
	ret
#endm

#macro LD_IrrI_r $1, $2
	xld.w %r10, [%r12+WRITE]
	xld.uh %r13, [%r12+$1]
	xld.ub %r14, [%r12+$2]
	call %r10
	ret
#endm

#macro LD_Irr_dI_n $1
	xld.w %r10, [%r12+WRITE]
	xld.uh %r13, [%r12+$1]		; rr+d
	ld.b %r14, %r14			; *anti-interlock*
	add %r13, %r14
	call.d %r10
	ld.w %r14, %r15			; *delay*
	ret
#endm

#macro LD_Irr_dI_r $1, $2
	xld.w %r10, [%r12+WRITE]
	xld.uh %r13, [%r12+$1]		; rr+d
	ld.b %r14, %r14			; *anti-interlock*
	add %r13, %r14
	xld.ub %r14, [%r12+$2]
	call %r10
	ret
#endm

;****************************************************************************

	.global z80op_LD_A_IlmI
z80op_LD_A_IlmI:
	LD_r_IlmI A

	.global z80op_LD_A_IBCI
z80op_LD_A_IBCI:
	LD_r_IrrI A, BC
	.global z80op_LD_A_IDEI
z80op_LD_A_IDEI:
	LD_r_IrrI A, DE
	.global z80op_LD_A_IHLI
z80op_LD_A_IHLI:
	LD_r_IrrI A, HL
	.global z80op_LD_B_IHLI
z80op_LD_B_IHLI:
	LD_r_IrrI B, HL
	.global z80op_LD_C_IHLI
z80op_LD_C_IHLI:
	LD_r_IrrI C, HL
	.global z80op_LD_D_IHLI
z80op_LD_D_IHLI:
	LD_r_IrrI D, HL
	.global z80op_LD_E_IHLI
z80op_LD_E_IHLI:
	LD_r_IrrI E, HL
	.global z80op_LD_H_IHLI
z80op_LD_H_IHLI:
	LD_r_IrrI H, HL
	.global z80op_LD_L_IHLI
z80op_LD_L_IHLI:
	LD_r_IrrI L, HL

	.global z80op_LD_A_IIX_dI
z80op_LD_A_IIX_dI:
	LD_r_Irr_dI A, IX
	.global z80op_LD_B_IIX_dI
z80op_LD_B_IIX_dI:
	LD_r_Irr_dI B, IX
	.global z80op_LD_C_IIX_dI
z80op_LD_C_IIX_dI:
	LD_r_Irr_dI C, IX
	.global z80op_LD_D_IIX_dI
z80op_LD_D_IIX_dI:
	LD_r_Irr_dI D, IX
	.global z80op_LD_E_IIX_dI
z80op_LD_E_IIX_dI:
	LD_r_Irr_dI E, IX
	.global z80op_LD_H_IIX_dI
z80op_LD_H_IIX_dI:
	LD_r_Irr_dI H, IX
	.global z80op_LD_L_IIX_dI
z80op_LD_L_IIX_dI:
	LD_r_Irr_dI L, IX
	.global z80op_LD_A_IIY_dI
z80op_LD_A_IIY_dI:
	LD_r_Irr_dI A, IY
	.global z80op_LD_B_IIY_dI
z80op_LD_B_IIY_dI:
	LD_r_Irr_dI B, IY
	.global z80op_LD_C_IIY_dI
z80op_LD_C_IIY_dI:
	LD_r_Irr_dI C, IY
	.global z80op_LD_D_IIY_dI
z80op_LD_D_IIY_dI:
	LD_r_Irr_dI D, IY
	.global z80op_LD_E_IIY_dI
z80op_LD_E_IIY_dI:
	LD_r_Irr_dI E, IY
	.global z80op_LD_H_IIY_dI
z80op_LD_H_IIY_dI:
	LD_r_Irr_dI H, IY
	.global z80op_LD_L_IIY_dI
z80op_LD_L_IIY_dI:
	LD_r_Irr_dI L, IY

	.global z80op_LD_IlmI_A
z80op_LD_IlmI_A:
	LD_IlmI_r A

	.global z80op_LD_IHLI_n
z80op_LD_IHLI_n:
	LD_IrrI_n HL

	.global z80op_LD_IBCI_A
z80op_LD_IBCI_A:
	LD_IrrI_r BC, A
	.global z80op_LD_IDEI_A
z80op_LD_IDEI_A:
	LD_IrrI_r DE, A
	.global z80op_LD_IHLI_A
z80op_LD_IHLI_A:
	LD_IrrI_r HL, A
	.global z80op_LD_IHLI_B
z80op_LD_IHLI_B:
	LD_IrrI_r HL, B
	.global z80op_LD_IHLI_C
z80op_LD_IHLI_C:
	LD_IrrI_r HL, C
	.global z80op_LD_IHLI_D
z80op_LD_IHLI_D:
	LD_IrrI_r HL, D
	.global z80op_LD_IHLI_E
z80op_LD_IHLI_E:
	LD_IrrI_r HL, E
	.global z80op_LD_IHLI_H
z80op_LD_IHLI_H:
	LD_IrrI_r HL, H
	.global z80op_LD_IHLI_L
z80op_LD_IHLI_L:
	LD_IrrI_r HL, L

	.global z80op_LD_IIX_dI_n
z80op_LD_IIX_dI_n:
	LD_Irr_dI_n IX
	.global z80op_LD_IIY_dI_n
z80op_LD_IIY_dI_n:
	LD_Irr_dI_n IY

	.global z80op_LD_IIX_dI_A
z80op_LD_IIX_dI_A:
	LD_Irr_dI_r IX, A
	.global z80op_LD_IIX_dI_B
z80op_LD_IIX_dI_B:
	LD_Irr_dI_r IX, B
	.global z80op_LD_IIX_dI_C
z80op_LD_IIX_dI_C:
	LD_Irr_dI_r IX, C
	.global z80op_LD_IIX_dI_D
z80op_LD_IIX_dI_D:
	LD_Irr_dI_r IX, D
	.global z80op_LD_IIX_dI_E
z80op_LD_IIX_dI_E:
	LD_Irr_dI_r IX, E
	.global z80op_LD_IIX_dI_H
z80op_LD_IIX_dI_H:
	LD_Irr_dI_r IX, H
	.global z80op_LD_IIX_dI_L
z80op_LD_IIX_dI_L:
	LD_Irr_dI_r IX, L
	.global z80op_LD_IIY_dI_A
z80op_LD_IIY_dI_A:
	LD_Irr_dI_r IY, A
	.global z80op_LD_IIY_dI_B
z80op_LD_IIY_dI_B:
	LD_Irr_dI_r IY, B
	.global z80op_LD_IIY_dI_C
z80op_LD_IIY_dI_C:
	LD_Irr_dI_r IY, C
	.global z80op_LD_IIY_dI_D
z80op_LD_IIY_dI_D:
	LD_Irr_dI_r IY, D
	.global z80op_LD_IIY_dI_E
z80op_LD_IIY_dI_E:
	LD_Irr_dI_r IY, E
	.global z80op_LD_IIY_dI_H
z80op_LD_IIY_dI_H:
	LD_Irr_dI_r IY, H
	.global z80op_LD_IIY_dI_L
z80op_LD_IIY_dI_L:
	LD_Irr_dI_r IY, L

;****************************************************************************
;	16-Bit Load Group
;****************************************************************************

#macro LD_rr_rr $1, $2
	xld.uh %r10, [%r12+$2]
	xld.h [%r12+$1], %r10
	ret
#endm

#macro LD_rr_lm $1
	xsll %r15, 8
	or %r14, %r15
	xld.h [%r12+$1], %r14
	ret
#endm

#macro LD_rr_IlmI $1
	pushn %r1
	;
	ld.w %r1, %r15			; (lm+0)
	xsll %r1, 8
	or %r1, %r14
	;
	xld.w %r10, [%r12+READ]
	ld.uh %r13, %r1
	call.d %r10
	ld.w %r0, %r12			; *delay*
	xld.b [%r0+($1+0)], %r10	; LO
	;
	xadd %r1, %r1, 1		; (lm+1)
	;
	xld.w %r10, [%r0+READ]
	ld.uh %r13, %r1
	call.d %r10
	ld.w %r12, %r0			; *delay*
	xld.b [%r0+($1+1)], %r10	; HI
	;
	popn %r1
	ret
#endm

#macro LD_IlmI_rr $1
	pushn %r1
	;
	ld.w %r1, %r15			; (lm+0)
	xsll %r1, 8
	or %r1, %r14
	;
	xld.w %r10, [%r12+WRITE]
	ld.uh %r13, %r1
	xld.ub %r14, [%r12+($1+0)]	; LO
	call.d %r10
	ld.w %r0, %r12			; *delay*
	;
	xadd %r1, %r1, 1		; (lm+1)
	;
	xld.w %r10, [%r0+WRITE]
	ld.uh %r13, %r1
	xld.ub %r14, [%r0+($1+1)]	; HI
	call.d %r10
	ld.w %r12, %r0			; *delay*
	;
	popn %r1
	ret
#endm

#macro POP_rr $1
	pushn %r1
	;
	xld.uh %r1, [%r12+SP]		; SP
	;
	xld.w %r10, [%r12+READ]
	ld.uh %r13, %r1			; *anti-interlock*
	call.d %r10
	ld.w %r0, %r12			; *delay*
	xld.b [%r0+($1+0)], %r10	; LO
	xadd %r1, %r1, 1		; SP++
	;
	xld.w %r10, [%r0+READ]
	ld.uh %r13, %r1			; *anti-interlock*
	call.d %r10
	ld.w %r12, %r0			; *delay*
	xld.b [%r0+($1+1)], %r10	; HI
	xadd %r1, %r1, 1		; SP++
	;
	xld.h [%r0+SP], %r1		; SP
	;
	popn %r1
	ret
#endm

#macro PUSH_rr $1
	pushn %r1
	;
	xld.uh %r1, [%r12+SP]		; SP
	;
	xld.w %r10, [%r12+WRITE]
	xsub %r1, %r1, 1		; SP--
	ld.uh %r13, %r1
	xld.ub %r14, [%r12+($1+1)]	; HI
	call.d %r10
	ld.w %r0, %r12			; *delay*
	;
	xld.w %r10, [%r0+WRITE]
	xsub %r1, %r1, 1		; SP--
	ld.uh %r13, %r1
	xld.ub %r14, [%r0+($1+0)]	; LO
	call.d %r10
	ld.w %r12, %r0			; *delay*
	;
	xld.h [%r0+SP], %r1		; SP
	;
	popn %r1
	ret
#endm

;****************************************************************************

	.global z80op_LD_SP_HL
z80op_LD_SP_HL:
	LD_rr_rr SP, HL
	.global z80op_LD_SP_IX
z80op_LD_SP_IX:
	LD_rr_rr SP, IX
	.global z80op_LD_SP_IY
z80op_LD_SP_IY:
	LD_rr_rr SP, IY

	.global z80op_LD_BC_lm
z80op_LD_BC_lm:
	LD_rr_lm BC
	.global z80op_LD_DE_lm
z80op_LD_DE_lm:
	LD_rr_lm DE
	.global z80op_LD_HL_lm
z80op_LD_HL_lm:
	LD_rr_lm HL
	.global z80op_LD_SP_lm
z80op_LD_SP_lm:
	LD_rr_lm SP
	.global z80op_LD_IX_lm
z80op_LD_IX_lm:
	LD_rr_lm IX
	.global z80op_LD_IY_lm
z80op_LD_IY_lm:
	LD_rr_lm IY

	.global z80op_LD_BC_IlmI
z80op_LD_BC_IlmI:
	LD_rr_IlmI BC
	.global z80op_LD_DE_IlmI
z80op_LD_DE_IlmI:
	LD_rr_IlmI DE
	.global z80op_LD_HL_IlmI
z80op_LD_HL_IlmI:
	LD_rr_IlmI HL
	.global z80op_LD_SP_IlmI
z80op_LD_SP_IlmI:
	LD_rr_IlmI SP
	.global z80op_LD_IX_IlmI
z80op_LD_IX_IlmI:
	LD_rr_IlmI IX
	.global z80op_LD_IY_IlmI
z80op_LD_IY_IlmI:
	LD_rr_IlmI IY

	.global z80op_LD_IlmI_BC
z80op_LD_IlmI_BC:
	LD_IlmI_rr BC
	.global z80op_LD_IlmI_DE
z80op_LD_IlmI_DE:
	LD_IlmI_rr DE
	.global z80op_LD_IlmI_HL
z80op_LD_IlmI_HL:
	LD_IlmI_rr HL
	.global z80op_LD_IlmI_SP
z80op_LD_IlmI_SP:
	LD_IlmI_rr SP
	.global z80op_LD_IlmI_IX
z80op_LD_IlmI_IX:
	LD_IlmI_rr IX
	.global z80op_LD_IlmI_IY
z80op_LD_IlmI_IY:
	LD_IlmI_rr IY

	.global z80op_POP_AF
z80op_POP_AF:
	POP_rr AF
	.global z80op_POP_BC
z80op_POP_BC:
	POP_rr BC
	.global z80op_POP_DE
z80op_POP_DE:
	POP_rr DE
	.global z80op_POP_HL
z80op_POP_HL:
	POP_rr HL
	.global z80op_POP_IX
z80op_POP_IX:
	POP_rr IX
	.global z80op_POP_IY
z80op_POP_IY:
	POP_rr IY

	.global z80op_PUSH_AF
z80op_PUSH_AF:
	PUSH_rr AF
	.global z80op_PUSH_BC
z80op_PUSH_BC:
	PUSH_rr BC
	.global z80op_PUSH_DE
z80op_PUSH_DE:
	PUSH_rr DE
	.global z80op_PUSH_HL
z80op_PUSH_HL:
	PUSH_rr HL
	.global z80op_PUSH_IX
z80op_PUSH_IX:
	PUSH_rr IX
	.global z80op_PUSH_IY
z80op_PUSH_IY:
	PUSH_rr IY

;****************************************************************************
;	Jump Group
;****************************************************************************

#macro JP_lm
	xsll %r15, 8			; lm
	or %r14, %r15
	xld.h [%r12+PC], %r14		; PC
	ret
#endm

#macro JP_c_lm $1
	xbtst [%r12+F], $1
	xjreq $$1
	;
	xsll %r15, 8			; lm
	or %r14, %r15
	;
	xld.w %r10, [%r0+CYCLE]		; CYCLE -= 7
	xld.h [%r12+PC], %r14		; PC *anti-interlock*
	xsub %r10, %r10, 7
	xld.w [%r0+CYCLE], %r10
$$1:
	ret
#endm

#macro JP_Nc_lm $1
	xbtst [%r12+F], $1
	xjrne $$1
	;
	xsll %r15, 8			; lm
	or %r14, %r15
	;
	xld.w %r10, [%r0+CYCLE]		; CYCLE -= 7
	xld.h [%r12+PC], %r14		; PC *anti-interlock*
	xsub %r10, %r10, 7
	xld.w [%r0+CYCLE], %r10
$$1:
	ret
#endm

#macro JR_e
	xld.uh %r10, [%r12+PC]		; PC+e
	ld.b %r14, %r14			; *anti-interlock*
	add %r14, %r10
	xld.h [%r12+PC], %r14		; PC
	ret
#endm

#macro JR_c_e $1
	xbtst [%r12+F], $1
	xjreq $$1
	;
	xld.uh %r10, [%r12+PC]		; PC+e
	ld.b %r14, %r14			; *anti-interlock*
	add %r14, %r10
	;
	xld.w %r10, [%r0+CYCLE]		; CYCLE -= 5
	xld.h [%r12+PC], %r14		; PC *anti-interlock*
	xsub %r10, %r10, 5
	xld.w [%r0+CYCLE], %r10
$$1:
	ret
#endm

#macro JR_Nc_e $1
	xbtst [%r12+F], $1
	xjrne $$1
	;
	xld.uh %r10, [%r12+PC]		; PC+e
	ld.b %r14, %r14			; *anti-interlock*
	add %r14, %r10
	;
	xld.w %r10, [%r0+CYCLE]		; CYCLE -= 5
	xld.h [%r12+PC], %r14		; PC *anti-interlock*
	xsub %r10, %r10, 5
	xld.w [%r0+CYCLE], %r10
$$1:
	ret
#endm

#macro DJNZ_e
	xld.ub %r10, [%r12+B]		; --B
	xsub %r10, %r10, 1
	xld.b [%r12+B], %r10
	xjreq $$1
	;
	xld.uh %r10, [%r12+PC]		; PC+e
	ld.b %r14, %r14			; *anti-interlock*
	add %r14, %r10
	;
	xld.w %r10, [%r0+CYCLE]		; CYCLE -= 5
	xld.h [%r12+PC], %r14		; PC *anti-interlock*
	xsub %r10, %r10, 5
	xld.w [%r0+CYCLE], %r10
$$1:
	ret
#endm

;****************************************************************************

	.global z80op_JP_lm
z80op_JP_lm:
	JP_lm
	.global z80op_JP_Z_lm
z80op_JP_Z_lm:
	JP_c_lm 6
	.global z80op_JP_NZ_lm
z80op_JP_NZ_lm:
	JP_Nc_lm 6
	.global z80op_JP_C_lm
z80op_JP_C_lm:
	JP_c_lm 0
	.global z80op_JP_NC_lm
z80op_JP_NC_lm:
	JP_Nc_lm 0
	.global z80op_JP_PE_lm
z80op_JP_PE_lm:
	JP_c_lm 2
	.global z80op_JP_PO_lm
z80op_JP_PO_lm:
	JP_Nc_lm 2
	.global z80op_JP_M_lm
z80op_JP_M_lm:
	JP_c_lm 7
	.global z80op_JP_P_lm
z80op_JP_P_lm:
	JP_Nc_lm 7

	.global z80op_JR_e
z80op_JR_e:
	JR_e
	.global z80op_JR_Z_e
z80op_JR_Z_e:
	JR_c_e 6
	.global z80op_JR_NZ_e
z80op_JR_NZ_e:
	JR_Nc_e 6
	.global z80op_JR_C_e
z80op_JR_C_e:
	JR_c_e 0
	.global z80op_JR_NC_e
z80op_JR_NC_e:
	JR_Nc_e 0

	.global z80op_DJNZ_e
z80op_DJNZ_e:
	DJNZ_e

;****************************************************************************
;	Call and Return Group
;****************************************************************************

#macro CALL_lm
	pushn %r2
	;
	ld.w %r2, %r15			; lm
	xsll %r2, 8
	or %r2, %r14
	;
	xld.uh %r1, [%r12+SP]		; SP
	;
	xld.w %r10, [%r12+WRITE]
	xsub %r1, %r1, 1		; SP--
	ld.uh %r13, %r1
	xld.ub %r14, [%r12+(PC+1)]	; HI(PC)
	call.d %r10
	ld.w %r0, %r12			; *delay*
	;
	xld.w %r10, [%r0+WRITE]
	xsub %r1, %r1, 1		; SP--
	ld.uh %r13, %r1
	xld.ub %r14, [%r0+(PC+0)]	; LO(PC)
	call.d %r10
	ld.w %r12, %r0			; *delay*
	;
	xld.h [%r0+SP], %r1		; SP
	;
	xld.h [%r0+PC], %r2		; PC
	;
	popn %r2
	ret
#endm

#macro CALL_c_lm $1
	xbtst [%r12+F], $1
	xjreq $$1
	;
	pushn %r2
	;
	ld.w %r2, %r15			; lm
	xsll %r2, 8
	or %r2, %r14
	;
	xld.uh %r1, [%r12+SP]		; SP
	;
	xld.w %r10, [%r12+WRITE]
	xsub %r1, %r1, 1		; SP--
	ld.uh %r13, %r1
	xld.ub %r14, [%r12+(PC+1)]	; HI(PC)
	call.d %r10
	ld.w %r0, %r12			; *delay*
	;
	xld.w %r10, [%r0+WRITE]
	xsub %r1, %r1, 1		; SP--
	ld.uh %r13, %r1
	xld.ub %r14, [%r0+(PC+0)]	; LO(PC)
	call.d %r10
	ld.w %r12, %r0			; *delay*
	;
	xld.h [%r0+SP], %r1		; SP
	;
	xld.w %r10, [%r0+CYCLE]		; CYCLE -= 7
	xld.h [%r0+PC], %r2		; PC *anti-interlock*
	xsub %r10, %r10, 7
	xld.w [%r0+CYCLE], %r10
	;
	popn %r2
$$1:
	ret
#endm

#macro CALL_Nc_lm $1
	xbtst [%r12+F], $1
	xjrne $$1
	;
	pushn %r2
	;
	ld.w %r2, %r15			; lm
	xsll %r2, 8
	or %r2, %r14
	;
	xld.uh %r1, [%r12+SP]		; SP
	;
	xld.w %r10, [%r12+WRITE]
	xsub %r1, %r1, 1		; SP--
	ld.uh %r13, %r1
	xld.ub %r14, [%r12+(PC+1)]	; HI(PC)
	call.d %r10
	ld.w %r0, %r12			; *delay*
	;
	xld.w %r10, [%r0+WRITE]
	xsub %r1, %r1, 1		; SP--
	ld.uh %r13, %r1
	xld.ub %r14, [%r0+(PC+0)]	; LO(PC)
	call.d %r10
	ld.w %r12, %r0			; *delay*
	;
	xld.h [%r0+SP], %r1		; SP
	;
	xld.w %r10, [%r0+CYCLE]		; CYCLE -= 7
	xld.h [%r0+PC], %r2		; PC *anti-interlock*
	xsub %r10, %r10, 7
	xld.w [%r0+CYCLE], %r10
	;
	popn %r2
$$1:
	ret
#endm

#macro RET
	pushn %r1
	;
	xld.uh %r1, [%r12+SP]		; SP
	;
	xld.w %r10, [%r12+READ]
	ld.uh %r13, %r1			; *anti-interlock*
	call.d %r10
	ld.w %r0, %r12			; *delay*
	xld.b [%r0+(PC+0)], %r10	; LO(PC)
	xadd %r1, %r1, 1		; SP++
	;
	xld.w %r10, [%r0+READ]
	ld.uh %r13, %r1			; *anti-interlock*
	call.d %r10
	ld.w %r12, %r0			; *delay*
	xld.b [%r0+(PC+1)], %r10	; HI(PC)
	xadd %r1, %r1, 1		; SP++
	;
	xld.h [%r0+SP], %r1		; SP
	;
	popn %r1
	ret
#endm

#macro RET_c $1
	xbtst [%r12+F], $1
	xjreq $$1
	;
	pushn %r1
	;
	xld.uh %r1, [%r12+SP]		; SP
	;
	xld.w %r10, [%r12+READ]
	ld.uh %r13, %r1			; *anti-interlock*
	call.d %r10
	ld.w %r0, %r12			; *delay*
	xld.b [%r0+(PC+0)], %r10	; LO(PC)
	xadd %r1, %r1, 1		; SP++
	;
	xld.w %r10, [%r0+READ]
	ld.uh %r13, %r1			; *anti-interlock*
	call.d %r10
	ld.w %r12, %r0			; *delay*
	xld.b [%r0+(PC+1)], %r10	; HI(PC)
	xadd %r1, %r1, 1		; SP++
	;
	xld.h [%r0+SP], %r1		; SP
	;
	popn %r1
$$1:
	ret
#endm

#macro RET_Nc $1
	xbtst [%r12+F], $1
	xjrne $$1
	;
	pushn %r1
	;
	xld.uh %r1, [%r12+SP]		; SP
	;
	xld.w %r10, [%r12+READ]
	ld.uh %r13, %r1			; *anti-interlock*
	call.d %r10
	ld.w %r0, %r12			; *delay*
	xld.b [%r0+(PC+0)], %r10	; LO(PC)
	xadd %r1, %r1, 1		; SP++
	;
	xld.w %r10, [%r0+READ]
	ld.uh %r13, %r1			; *anti-interlock*
	call.d %r10
	ld.w %r12, %r0			; *delay*
	xld.b [%r0+(PC+1)], %r10	; HI(PC)
	xadd %r1, %r1, 1		; SP++
	;
	xld.h [%r0+SP], %r1		; SP
	;
	popn %r1
$$1:
	ret
#endm

#macro RETN
	pushn %r1
	;
	xld.uh %r1, [%r12+SP]		; SP
	;
	xld.w %r10, [%r12+READ]
	ld.uh %r13, %r1			; *anti-interlock*
	call.d %r10
	ld.w %r0, %r12			; *delay*
	xld.b [%r0+(PC+0)], %r10	; LO(PC)
	xadd %r1, %r1, 1		; SP++
	;
	xld.w %r10, [%r0+READ]
	ld.uh %r13, %r1			; *anti-interlock*
	call.d %r10
	ld.w %r12, %r0			; *delay*
	xld.b [%r0+(PC+1)], %r10	; HI(PC)
	xadd %r1, %r1, 1		; SP++
	;
	xld.ub %r10, [%r0+IFF2]		; IFF1 = IFF2
	xld.h [%r0+SP], %r1		; SP *anti-interlock*
	xld.b [%r0+IFF1], %r10
	;
	popn %r1
	ret
#endm

#macro RST_n $1
	pushn %r1
	;
	xld.uh %r1, [%r12+SP]		; SP
	;
	xld.w %r10, [%r12+WRITE]
	xsub %r1, %r1, 1		; SP--
	ld.uh %r13, %r1
	xld.ub %r14, [%r12+(PC+1)]	; HI(PC)
	call.d %r10
	ld.w %r0, %r12			; *delay*
	;
	xld.w %r10, [%r0+WRITE]
	xsub %r1, %r1, 1		; SP--
	ld.uh %r13, %r1
	xld.ub %r14, [%r0+(PC+0)]	; LO(PC)
	call.d %r10
	ld.w %r12, %r0			; *delay*
	;
	xld.h [%r0+SP], %r1		; SP
	;
	xld.w %r10, $1			; PC
	xld.h [%r0+PC], %r10
	;
	popn %r1
	ret
#endm

;****************************************************************************

	.global z80op_CALL_lm
z80op_CALL_lm:
	CALL_lm
	.global z80op_CALL_Z_lm
z80op_CALL_Z_lm:
	CALL_c_lm 6
	.global z80op_CALL_NZ_lm
z80op_CALL_NZ_lm:
	CALL_Nc_lm 6
	.global z80op_CALL_C_lm
z80op_CALL_C_lm:
	CALL_c_lm 0
	.global z80op_CALL_NC_lm
z80op_CALL_NC_lm:
	CALL_Nc_lm 0
	.global z80op_CALL_PE_lm
z80op_CALL_PE_lm:
	CALL_c_lm 2
	.global z80op_CALL_PO_lm
z80op_CALL_PO_lm:
	CALL_Nc_lm 2
	.global z80op_CALL_M_lm
z80op_CALL_M_lm:
	CALL_c_lm 7
	.global z80op_CALL_P_lm
z80op_CALL_P_lm:
	CALL_Nc_lm 7

	.global z80op_RET
z80op_RET:
	RET
	.global z80op_RET_Z
z80op_RET_Z:
	RET_c 6
	.global z80op_RET_NZ
z80op_RET_NZ:
	RET_Nc 6
	.global z80op_RET_C
z80op_RET_C:
	RET_c 0
	.global z80op_RET_NC
z80op_RET_NC:
	RET_Nc 0
	.global z80op_RET_PE
z80op_RET_PE:
	RET_c 2
	.global z80op_RET_PO
z80op_RET_PO:
	RET_Nc 2
	.global z80op_RET_M
z80op_RET_M:
	RET_c 7
	.global z80op_RET_P
z80op_RET_P:
	RET_Nc 7

	.global z80op_RETI
z80op_RETI:
	RET /*RETI*/
	.global z80op_RETN
z80op_RETN:
	RETN

	.global z80op_RST_00H
z80op_RST_00H:
	RST_n 0x00
	.global z80op_RST_08H
z80op_RST_08H:
	RST_n 0x08
	.global z80op_RST_10H
z80op_RST_10H:
	RST_n 0x10
	.global z80op_RST_18H
z80op_RST_18H:
	RST_n 0x18
	.global z80op_RST_20H
z80op_RST_20H:
	RST_n 0x20
	.global z80op_RST_28H
z80op_RST_28H:
	RST_n 0x28
	.global z80op_RST_30H
z80op_RST_30H:
	RST_n 0x30
	.global z80op_RST_38H
z80op_RST_38H:
	RST_n 0x38

;****************************************************************************
;
;****************************************************************************

#endif /*Z80_ASM*/
